# Yet_Another_Anime_List
[![Build Status](https://app.bitrise.io/app/360dfa050cdd6b64/status.svg?token=aLou19Q5u1PVlVzWLad97g)](https://app.bitrise.io/app/360dfa050cdd6b64)
[![codebeat badge](https://codebeat.co/badges/53339772-b0b0-4aa9-95fe-38642f526ee7)](https://codebeat.co/projects/github-com-sanmiade-yet_another_anime_list-dev)

# YetAnotherAnimeList
I just finished reading Android Test-Driven Development book by Raywenderlich, so I decided to make an application to practice what i learnt from the book. You can get the book here, https://store.raywenderlich.com/products/android-test-driven-development-by-tutorials.

Yet Another Anime List displays a list of trending and upcoming animes, and details about the animes. It allows users to favourite animes they like. It was developed using Test Driven Development And Continous Integration using Bitrise.


## Libraries
*   [Dagger2](https://github.com/google/dagger)
*   [AssistedInject](https://github.com/square/AssistedInject)
*   [Room]
*   [Rxjava](https://github.com/ReactiveX/RxJava)
*   [Retrofit](https://github.com/square/retrofit)  
*   [Retrofit Rxjava2 Adapter](https://github.com/square/retrofit/tree/master/retrofit-adapters/rxjava2)
*   [Moshi](https://github.com/square/moshi)
*   [Mockito](https://github.com/mockito/mockito)
*   [Mockito-Kotlin](https://github.com/nhaarman/mockito-kotlin)
*   [ViewModel](https://developer.android.com/topic/libraries/architecture/viewmodel)
*   [Faker](https://github.com/DiUS/java-faker)
*   [Mockwebserver](https://github.com/square/okhttp/tree/master/mockwebserver)
*   [Lottie](https://github.com/airbnb/lottie-android)
*   [Truth](https://github.com/google/truth)
*   [Glide4](https://bumptech.github.io/glide/doc/download-setup.html)

## Features
* Local persistence with Room.
* Unit and Integration testing the network layer with Truth and Mockwebserver.
* Unit testing the database layer with Truth and inMemory Database.
* Integration testing ViewModels with Truth and Mockito.
* Dependency injection with Dagger2.
* MVVM achitecture.
* Continous Integration using Bitrise.


<h2 align="left">Screenshots</h2>
<h4 align="center">
<img src="https://res.cloudinary.com/dabxauefu/image/upload/v1593889410/Screenshot_2020-07-04-19-28-47-449_com.sanmidev.yetanotheranimelist.debug_pkmfbg.jpg" width="30%" vspace="10" hspace="10">
<img src="https://res.cloudinary.com/dabxauefu/image/upload/v1593889380/Screenshot_2020-07-04-19-28-56-737_com.sanmidev.yetanotheranimelist.debug_bsg6cg.jpg" width="30%" vspace="10" hspace="10">
<img src="https://res.cloudinary.com/dabxauefu/image/upload/v1593889592/Screenshot_2020-07-04-19-29-17-099_com.sanmidev.yetanotheranimelist.debug_btyuxf.jpg" width="30%" vspace="10" hspace="10""><br>

## Author
Oluwasanmi Aderibigbe

## License
This project is licensed under the Apache License 2.0 - See: http://www.apache.org/licenses/LICENSE-2.0.txt
